package cn.com.infosec.i18n;

import cn.com.infosec.i18n.filter.Filter;
import cn.com.infosec.i18n.filter.TrustedInput;
import cn.com.infosec.i18n.filter.UntrustedInput;
import cn.com.infosec.i18n.filter.UntrustedUrlInput;
import java.io.UnsupportedEncodingException;
import java.nio.charset.Charset;
import java.text.DateFormat;
import java.text.Format;
import java.text.MessageFormat;
import java.util.Locale;
import java.util.MissingResourceException;
import java.util.ResourceBundle;
import java.util.TimeZone;

public class LocalizedMessage {
   public static final String DEFAULT_ENCODING = "ISO-8859-1";
   protected final String id;
   protected final String resource;
   protected String encoding = "ISO-8859-1";
   protected FilteredArguments arguments;
   protected FilteredArguments extraArgs = null;
   protected Filter filter = null;
   protected ClassLoader loader = null;

   public LocalizedMessage(String resource, String id) {
      if (resource != null && id != null) {
         this.id = id;
         this.resource = resource;
         FilteredArguments resource1;
         resource1 = new FilteredArguments.<init>();
         this.arguments = resource1;
      } else {
         throw null;
      }
   }

   public LocalizedMessage(String resource, String id, String encoding) {
      if (resource != null && id != null) {
         this.id = id;
         this.resource = resource;
         this.arguments = new FilteredArguments();
         if (Charset.isSupported(encoding)) {
            this.encoding = encoding;
         } else {
            throw new UnsupportedEncodingException("The encoding \"" + encoding + "\" is not supported.");
         }
      } else {
         throw null;
      }
   }

   public LocalizedMessage(String resource, String id, Object[] arguments) {
      if (resource != null && id != null && arguments != null) {
         this.id = id;
         this.resource = resource;
         FilteredArguments resource1;
         resource1 = new FilteredArguments.<init>(arguments);
         this.arguments = resource1;
      } else {
         throw null;
      }
   }

   public LocalizedMessage(String resource, String id, String encoding, Object[] arguments) {
      if (resource != null && id != null && arguments != null) {
         this.id = id;
         this.resource = resource;
         this.arguments = new FilteredArguments(arguments);
         if (Charset.isSupported(encoding)) {
            this.encoding = encoding;
         } else {
            throw new UnsupportedEncodingException("The encoding \"" + encoding + "\" is not supported.");
         }
      } else {
         throw null;
      }
   }

   public String getEntry(String key, Locale loc, TimeZone timezone) {
      String var4 = this.id;
      if (key != null) {
         var4 = var4 + "." + key;
      }

      UnsupportedEncodingException var10000;
      label120: {
         String var5;
         label121: {
            boolean var10001;
            ClassLoader var35;
            try {
               var35 = this.loader;
            } catch (MissingResourceException var27) {
               var10001 = false;
               break label121;
            } catch (UnsupportedEncodingException var28) {
               var10000 = var28;
               var10001 = false;
               break label120;
            }

            ClassLoader key1 = var35;
            ResourceBundle var36;
            if (var35 == null) {
               try {
                  var36 = ResourceBundle.getBundle(this.resource, loc);
               } catch (MissingResourceException var25) {
                  var10001 = false;
                  break label121;
               } catch (UnsupportedEncodingException var26) {
                  var10000 = var26;
                  var10001 = false;
                  break label120;
               }
            } else {
               try {
                  var36 = ResourceBundle.getBundle(this.resource, loc, key1);
               } catch (MissingResourceException var23) {
                  var10001 = false;
                  break label121;
               } catch (UnsupportedEncodingException var24) {
                  var10000 = var24;
                  var10001 = false;
                  break label120;
               }
            }

            ResourceBundle key2 = var36;

            LocalizedMessage var37;
            String var39;
            try {
               var37 = this;
               var39 = key2.getString(var4);
            } catch (MissingResourceException var21) {
               var10001 = false;
               break label121;
            } catch (UnsupportedEncodingException var22) {
               var10000 = var22;
               var10001 = false;
               break label120;
            }

            key = var39;

            boolean var38;
            try {
               var38 = var37.encoding.equals("ISO-8859-1");
            } catch (MissingResourceException var19) {
               var10001 = false;
               break label121;
            } catch (UnsupportedEncodingException var20) {
               var10000 = var20;
               var10001 = false;
               break label120;
            }

            String var40;
            if (!var38) {
               try {
                  var40 = new String;
               } catch (MissingResourceException var17) {
                  var10001 = false;
                  break label121;
               } catch (UnsupportedEncodingException var18) {
                  var10000 = var18;
                  var10001 = false;
                  break label120;
               }

               var5 = var40;

               byte[] var10002;
               LocalizedMessage var41;
               try {
                  var41 = this;
                  var10002 = key.getBytes("ISO-8859-1");
               } catch (MissingResourceException var15) {
                  var10001 = false;
                  break label121;
               } catch (UnsupportedEncodingException var16) {
                  var10000 = var16;
                  var10001 = false;
                  break label120;
               }

               byte[] key3 = var10002;

               try {
                  var40.<init>(key3, var41.encoding);
               } catch (MissingResourceException var13) {
                  var10001 = false;
                  break label121;
               } catch (UnsupportedEncodingException var14) {
                  var10000 = var14;
                  var10001 = false;
                  break label120;
               }
            } else {
               var5 = key;
            }

            try {
               var38 = this.arguments.isEmpty();
            } catch (MissingResourceException var11) {
               var10001 = false;
               break label121;
            } catch (UnsupportedEncodingException var12) {
               var10000 = var12;
               var10001 = false;
               break label120;
            }

            if (!var38) {
               try {
                  var40 = this.formatWithTimeZone(var5, this.arguments.getFilteredArgs(loc), loc, timezone);
               } catch (MissingResourceException var9) {
                  var10001 = false;
                  break label121;
               } catch (UnsupportedEncodingException var10) {
                  var10000 = var10;
                  var10001 = false;
                  break label120;
               }

               var5 = var40;
            }

            try {
               return this.addExtraArgs(var5, loc);
            } catch (MissingResourceException var7) {
               var10001 = false;
            } catch (UnsupportedEncodingException var8) {
               var10000 = var8;
               var10001 = false;
               break label120;
            }
         }

         MissingEntryException key4 = new MissingEntryException;
         String timezone1 = "Can't find entry " + var4 + " in resource file " + this.resource + ".";
         var5 = this.resource;
         ClassLoader var6;
         if ((var6 = this.loader) == null) {
            var6 = this.getClassLoader();
         }

         key4.<init>(timezone1, var5, var4, loc, var6);
         throw key4;
      }

      UnsupportedEncodingException var29 = var10000;
      throw new RuntimeException(var29);
   }

   protected String formatWithTimeZone(String template, Object[] arguments, Locale locale, TimeZone timezone) {
      MessageFormat var6;
      MessageFormat var10001 = var6 = new MessageFormat;
      var6.<init>(" ");
      var6.setLocale(locale);
      var10001.applyPattern(template);
      if (!timezone.equals(TimeZone.getDefault())) {
         Format[] template1 = var6.getFormats();

         for(int locale1 = 0; locale1 < template1.length; ++locale1) {
            if (template1[locale1] instanceof DateFormat) {
               DateFormat var5;
               (var5 = (DateFormat)template1[locale1]).setTimeZone(timezone);
               var6.setFormat(locale1, var5);
            }
         }
      }

      return var6.format(arguments);
   }

   protected String addExtraArgs(String msg, Locale locale) {
      if (this.extraArgs != null) {
         StringBuffer var3;
         var3 = new StringBuffer.<init>(msg);
         Object[] locale1 = this.extraArgs.getFilteredArgs(locale);

         for(int msg1 = 0; msg1 < locale1.length; ++msg1) {
            var3.append(locale1[msg1]);
         }

         msg = var3.toString();
      }

      return msg;
   }

   public void setFilter(Filter filter) {
      this.arguments.setFilter(filter);
      FilteredArguments var2;
      if ((var2 = this.extraArgs) != null) {
         var2.setFilter(filter);
      }

      this.filter = filter;
   }

   public Filter getFilter() {
      return this.filter;
   }

   public void setClassLoader(ClassLoader loader) {
      this.loader = loader;
   }

   public ClassLoader getClassLoader() {
      return this.loader;
   }

   public String getId() {
      return this.id;
   }

   public String getResource() {
      return this.resource;
   }

   public Object[] getArguments() {
      return this.arguments.getArguments();
   }

   public void setExtraArgument(Object extraArg) {
      LocalizedMessage var10000 = this;
      Object[] var2;
      (var2 = new Object[1])[0] = extraArg;
      var10000.setExtraArguments(var2);
   }

   public void setExtraArguments(Object[] extraArgs) {
      if (extraArgs != null) {
         FilteredArguments var2;
         FilteredArguments var10000 = var2 = new FilteredArguments;
         var2.<init>(extraArgs);
         this.extraArgs = var2;
         var10000.setFilter(this.filter);
      } else {
         this.extraArgs = null;
      }

   }

   public Object[] getExtraArgs() {
      FilteredArguments var1;
      return (var1 = this.extraArgs) == null ? null : var1.getArguments();
   }

   public String toString() {
      StringBuffer var1;
      StringBuffer var10001 = var1 = new StringBuffer;
      var10001.<init>();
      var10001.append("Resource: \"").append(this.resource);
      var10001.append("\" Id: \"").append(this.id).append("\"");
      var10001.append(" Arguments: ").append(this.arguments.getArguments().length).append(" normal");
      FilteredArguments var2;
      if ((var2 = this.extraArgs) != null && var2.getArguments().length > 0) {
         var1.append(", ").append(this.extraArgs.getArguments().length).append(" extra");
      }

      var1.append(" Encoding: ").append(this.encoding);
      var1.append(" ClassLoader: ").append(this.loader);
      return var1.toString();
   }

   protected class FilteredArguments {
      protected static final int NO_FILTER = 0;
      protected static final int FILTER = 1;
      protected static final int FILTER_URL = 2;
      protected Filter filter;
      protected boolean[] isLocaleSpecific;
      protected int[] argFilterType;
      protected Object[] arguments;
      protected Object[] unpackedArgs;
      protected Object[] filteredArgs;

      FilteredArguments() {
         this(new Object[0]);
      }

      FilteredArguments(Object[] args) {
         this.filter = null;
         this.arguments = args;
         this.unpackedArgs = new Object[args.length];
         this.filteredArgs = new Object[args.length];
         this.isLocaleSpecific = new boolean[args.length];
         this.argFilterType = new int[args.length];

         for(int var3 = 0; var3 < args.length; ++var3) {
            if (args[var3] instanceof TrustedInput) {
               this.unpackedArgs[var3] = ((TrustedInput)args[var3]).getInput();
               this.argFilterType[var3] = 0;
            } else if (args[var3] instanceof UntrustedInput) {
               this.unpackedArgs[var3] = ((UntrustedInput)args[var3]).getInput();
               if (args[var3] instanceof UntrustedUrlInput) {
                  this.argFilterType[var3] = 2;
               } else {
                  this.argFilterType[var3] = 1;
               }
            } else {
               this.unpackedArgs[var3] = args[var3];
               this.argFilterType[var3] = 1;
            }

            this.isLocaleSpecific[var3] = this.unpackedArgs[var3] instanceof LocaleString;
         }

      }

      private Object filter(int type, Object obj) {
         Filter var3;
         if ((var3 = this.filter) != null) {
            if (obj == null) {
               obj = "null";
            }

            if (type != 0) {
               if (type != 1) {
                  return type != 2 ? null : var3.doFilterUrl(obj.toString());
               } else {
                  return var3.doFilter(obj.toString());
               }
            } else {
               return obj;
            }
         } else {
            return obj;
         }
      }

      public boolean isEmpty() {
         return this.unpackedArgs.length == 0;
      }

      public Object[] getArguments() {
         return this.arguments;
      }

      public Object[] getFilteredArgs(Locale locale) {
         Object[] var2 = new Object[this.unpackedArgs.length];

         Object[] var4;
         for(int var3 = 0; var3 < (var4 = this.unpackedArgs).length; ++var3) {
            Object[] var5;
            Object var7;
            if ((var5 = this.filteredArgs)[var3] != null) {
               var7 = var5[var3];
            } else {
               var7 = var4[var3];
               if (this.isLocaleSpecific[var3]) {
                  String var6 = ((LocaleString)var7).getLocaleString(locale);
                  var7 = this.filter(this.argFilterType[var3], var6);
               } else {
                  var7 = this.filter(this.argFilterType[var3], var7);
                  this.filteredArgs[var3] = var7;
               }
            }

            var2[var3] = var7;
         }

         return var2;
      }

      public Filter getFilter() {
         return this.filter;
      }

      public void setFilter(Filter filter) {
         if (filter != this.filter) {
            for(int var2 = 0; var2 < this.unpackedArgs.length; ++var2) {
               this.filteredArgs[var2] = null;
            }
         }

         this.filter = filter;
      }
   }
}
